/*

*/
#property copyright ""
#property link      ""
#property indicator_buffers 6
#property indicator_chart_window

#property indicator_color1 Red
#property indicator_color2 DarkViolet
#property indicator_color3 Green
#property indicator_color4 Red
#property indicator_color5 DarkViolet
#property indicator_color6 Green


#property indicator_width1 4
#property indicator_width2 3
#property indicator_width3 4
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1

//---- input parameters

extern double     Points1        = 3; 
extern double     Points2        = 9; 
extern double     Points3        = 15; 
extern bool       DrawSignals    = false; 
extern int        Code_Sml       = 158;
extern int        Code_Mid       = 159;
extern int        Code_Big       = 178;

//double UpLine[];
//double BotLine[];

double ZZ_Sml[]; 
double ZZ_Mid[];
double ZZ_Big[];
double Sig_Sml[]; 
double Sig_Mid[];
double Sig_Big[];


int SigCode = 171; //167
double point;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
 
  {
  
   if(Digits == 3 || Digits == 5)
   point = Point*10;
   else point = Point;
   
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
   SetIndexEmptyValue(5,0.0);
     
   
   SetIndexBuffer(0,ZZ_Sml);
   SetIndexBuffer(1,ZZ_Mid);
   SetIndexBuffer(2,ZZ_Big);
   SetIndexBuffer(3,Sig_Sml);
   SetIndexBuffer(4,Sig_Mid);
   SetIndexBuffer(5,Sig_Big);
   
   SetIndexStyle(0,DRAW_ARROW); 
   SetIndexStyle(1,DRAW_ARROW); 
   SetIndexStyle(2,DRAW_ARROW); 
   
   if(DrawSignals)
   {
      SetIndexStyle(3,DRAW_ARROW); 
      SetIndexStyle(4,DRAW_ARROW); 
      SetIndexStyle(5,DRAW_ARROW);
      SetIndexArrow(3, SigCode);
      SetIndexArrow(4, SigCode);
      SetIndexArrow(5, SigCode); 
   }
   else
   {
      SetIndexStyle(3,DRAW_NONE); 
      SetIndexStyle(4,DRAW_NONE); 
      SetIndexStyle(5,DRAW_NONE);
   
   }
   SetIndexArrow(0,Code_Sml);
   SetIndexArrow(1,Code_Mid);
   SetIndexArrow(2,Code_Big); 
   
 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{

      ZZ_Calculate(ZZ_Sml, Sig_Sml, Points1);
      ZZ_Calculate(ZZ_Mid, Sig_Mid, Points2);
      ZZ_Calculate(ZZ_Big, Sig_Big, Points3);

            
   
   return(0);
}

//==============================================================================
//
//==============================================================================
void ZZ_Calculate(double& zz[], double& sig[], double deviat)
{

   int i; int LastBar;int nBars; 
   int LastHiBarNum=0;int LastLoBarNum;int initCount;
   double LastHi;double LastLo;
   bool findTrough; bool findPeak;//  findTrough=true,      
   
   
      int    counted_bars=IndicatorCounted();
         
         
         nBars=3000;
   
         if (nBars < Bars-1 )
         {
         LastHi=High[nBars-1];
         LastLo=Low[nBars-1];
         LastHiBarNum = nBars-1;
         LastLoBarNum = nBars-1;
         //UpLine[nBars-1]=LastHi; //.     
         //BotLine[nBars-1]=LastLo;
         findPeak=(true);
         initCount=nBars-2;
         }
         else
         {
         LastHi=High[Bars-1];
         LastLo=Low[Bars-1];
         LastHiBarNum = Bars-1;
         LastLoBarNum = Bars-1;
         //UpLine[Bars-1]=LastHi;
         //BotLine[Bars-1]=LastLo;
         findPeak=(true);
         initCount=Bars-2;
         }
   
         i = initCount;
         while(i >= LastBar)
         {
              zz[i]=0;  // ZZ    timeframe
         //------    	  ---------------------------------------------------------
   
   	      if (High[i]>=LastHi )
   		      {
   		      LastHi=High[i];
   		      LastHiBarNum=i;
   		      }
   		      
   		      
   		      //sig[i]=sig[i+1];
   		
   	      if (High[i] < LastHi) 
   		      {
   		      //if ((Low[i] < LastHi*( (100-Percent)/100 ) ) && findPeak)	// 
   			   if ((Low[i] < LastHi - point*deviat) && findPeak)
   			      {
   			      LastLo=Low[i];
   			        
   			        //if (ShowZZ==true)
   			        zz[LastHiBarNum]=LastHi;
   			      
   			      LastLoBarNum=i;
   			      sig[i]=LastHi;
   			      findPeak=false;
   			      findTrough=true;
   			      }		
   		      /*
   		      else
   			      {
   			      sig[i]=sig[i+1];
   			      } */
   		      }
   	        
   	      
         //------   -------------------------------------------------------------------
   
   	      if (Low[i]<=LastLo )// 
   		      {
   		      LastLo=Low[i];
   		      LastLoBarNum=i;
   		      }
   		     // sig[i]=sig[i+1];
   		
   	
   	      //if (Low[i] > LastLo )
   		   if (Low[i] > LastLo )
   		      {
   		      //if ((High[i] > LastLo*( (100+Percent)/100) ) 	&& findTrough )// 
   			   if ((High[i] > LastLo + point*deviat ) 	&& findTrough )// 
   			   
   			      {
   			      LastHi=High[i];
   			      
   			     // if (ShowZZ==true)
   			      zz[LastLoBarNum] = LastLo;
   			      
   			      LastHiBarNum=i;
   			      sig[i]=LastLo;
   			      findPeak=true;
   			      findTrough=false;
   			      }		
   		        /*
   		        else
   			      {
   			      sig[i]=sig[i+1];
   			      }*/
               }
               
               /*
               if(findPeak == true)
               sig[i] = LastLo;
               else
               sig[i] = 0;
               
               if(findTrough == true)
               sig[i] = LastHi;
               else
               sig[i] = 0;
               */
               
               
               
         i--;
         }











}